
comment $



     FOR 32 BIT PROTECDED MODE ONLY
 Writen by Adam Seychell


  VARIOUS PROCEDURES   

                                                                     
      THIS FILE CONTAINS USEFUL SCREEN I/O PROCEDURES			       
                                                                     
      THEY SHOULDN'T NEED TO BE CHANGED TO MUSH                      
                                                                     







  THE   PROCEDURES	    


  proc Name            Discription

 ClrScr          fills video memory (B8000h-B8FFFh) with  AX
             

PRINT_CHAR    prints a character AL with color AH at the cursor
                             AH = attribute byte  ( COLOR )
             

 TEXT          Prints a string at the cursor position.
              expects  :     EDX = offset of string in data segment
                             AH = attribute byte  ( COLOR )
             

HEX_DWORD     Usage	    HEX_????	arg
HEX_WORD      Prints the value of "arg" hexidecimal at the cursor position.
HEX_BYTE      		expects  :   A Dword passed through the stack
	      

BINARY_DWORD  Same as hex above except it prints in binary
BINARY_WORD  
BINARY_BYTE  

DEC_DWORD     Same as hex above except it prints in decimal
DEC_WORD     
DEC_BYTE     

SCROLL_SCREENScrolls the screen up a line.
             





$




.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME	CS:CODE32,DS:CODE32,FS:CODE32,GS:CODE32,SS:CODE32


INCLUDE 	dos32.inc
INCLUDE 	Misc.inc


; Contains the current cursor cordinates  used by the printing procs
Cursor_X	db	0; Contain the current cursor cordinates
Cursor_Y	db	24; used by the printing procs




;  CLEAR THE SCREEN ( FILL WITH ATTRIBUTES AH ) 
ClrScr  proc near USES edi ecx eax
        mov edi,_0b8000h
        cld
        xor al,al
        mov ecx,2000
        rep stosw
        ret
ClrScr endp


;  SCROLL THE SCREEN UP A LINE  
Scroll_Screen proc near USES esi edi ecx eax es
        mov es,CS:[ZERO_sel]
        mov edi,0b8000h
        mov esi,0B8000h+0a0h
        cld
        mov ecx,1000-40
        rep movs dword ptr  es:[edi],es:[esi]
        mov ecx,80      ;- now screen is scrolled up, must clear bottom line
@@:     mov byte ptr es:[0b8000h+(80*24*2)-2+ecx*2],0
        loop @B
	ret
Scroll_Screen endp





;PRINT TEXT
; PRINTS A STRING ON SCREEN ( TEXT MODE 3 )
; Expects  edx 			> offset of string in the data segment
;	   Cursor_X,Cursor_Y 	>  position (X,Y) on the screen
;	   ah 		     	> attribute byte ( colors )
;NOTE:  string ends with a '$'
;      Cursor_X is returned with the X position at the end of the string
TEXT proc near  USES eax edx
textlop:	mov al,[edx]
                inc edx
	        cmp al,'$'
	        jz exit_text
	        call print_char
               jmp textlop
exit_text:      ret
TEXT ENDP



; PRINT BINARY NUMBER OF THE ARGUMENT 
; Expects :
; Cursor_X,Cursor_Y   position (X,Y) on the screen
;

BinSizeSet PROC NEAR PASCAL USES EAX, color :DWORD
                mov     ah,byte ptr color
	binary_digit:
                rol     ecx,1
		mov	al,cl
		and	al,1
		add	al,'0'

                call	print_char	; send character to screen
                dec	dh
                jnz	binary_digit
        	ret
BinSizeSet ENDP


Bin_Dword   PROC NEAR PASCAL USES EDX ECX, value,Color:DWORD		; prints EAX
	mov dh,32
        mov ecx,DWORD PTR [value]
        invoke  binSizeSet, color
        RET
Bin_Dword	 ENDP


Bin_Word	      PROC NEAR PASCAL USES  EDX ECX,  value,Color:DWORD	  ; prints AX
	mov dh,16
        mov ecx,DWORD PTR [value]
	rol ecx,16
        invoke  binSizeSet, color
        RET
Bin_Word	ENDP


Bin_Byte	      PROC NEAR PASCAL USES  EDX ECX ,	value,Color:DWORD	    ; prints AL
	mov dh,8
        mov ecx,DWORD PTR [value]
	rol ecx,24
        invoke  binSizeSet, color
        RET
Bin_Byte	ENDP
;-------------------------------------------------------




; PRINT DECIMAL NUMBER OF THE argument 
; Expects :
; Cursor_X,Cursor_Y   position (X,Y) on the screen
;
;




DecSizeSet PROC NEAR PASCAL USES EAX EDX, color : dword

strt_dec:

dec83:
        mov	eax,ECX
        xor	edx,edx
        div	cs:Dec_divider[ESI]
        mov	ECX,EDX		; reuse remainder
		add al,'0'	; use quotient as digit number
		mov ah,byte ptr color	; print  digit color
		call	Print_Char	; send character to screen
        sub ESI,4
        jge dec83

	ret
align 4
dec_divider dd 1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000

DecSizeSet ENDP



DecDword   PROC NEAR PASCAL USES ESI ECX, value:DWORD		; prints EAX
        mov	ecx,DWORD PTR [value]
        mov     ESI,4*9
	INVOKE DecSizeSet, 07h
        RET
DecDword	 ENDP


DecWord	      PROC NEAR PASCAL USES ESI ECX,  value:DWORD	  ; prints AX
        mov	ecx,DWORD PTR [value]
        and     ecx,0ffffh
        mov     ESI,4*4
	INVOKE DecSizeSet, 07h
        RET
DecWord	ENDP


DecByte	      PROC NEAR PASCAL USES  ECX ESI,  value:DWORD	    ; prints AL
        mov	ecx,DWORD PTR [value]
        and     ecx,0ffh
        mov     ESI,4*2
	INVOKE DecSizeSet, 07h
        RET
DecByte	ENDP



Dec_Dword   PROC NEAR PASCAL USES ESI ECX, value:DWORD	,color:dword	; prints EAX
        mov	ecx,DWORD PTR [value]
        mov     ESI,4*9
	INVOKE DecSizeSet, color
        RET
Dec_Dword	 ENDP


Dec_Word	      PROC NEAR PASCAL USES ESI ECX,  value,color:DWORD	  ; prints AX
        mov	ecx,DWORD PTR [value]
        and     ecx,0ffffh
        mov     ESI,4*4
	INVOKE DecSizeSet, color
        RET
Dec_Word	ENDP


Dec_Byte	      PROC NEAR PASCAL USES  ECX ESI,  value,color:DWORD	    ; prints AL
        mov	ecx,DWORD PTR [value]
        and     ecx,0ffh
        mov     ESI,4*2
	INVOKE DecSizeSet, color
        RET
Dec_Byte	ENDP

;-------------------------------------------------------



; PRINT HexARY NUMBER OF THE Argumen 
;
; Expects :
; Cursor_X,Cursor_Y   position (X,Y) on the screen
;
HexSizeSet PROC NEAR PASCAL USES EAX EDX, color : dword
		MOV	AH,byte ptr color
	Hexary_digit:
                rol     ecx,4
		mov	al,cl
		and	al,0Fh
		.IF    al < 10
			add	al,'0'
                .ELSE
			add	al,'A'-10
                .ENDIF

		call	Print_Char	; send character to screen
                dec	dh
                jnz	Hexary_digit
        	ret
HexSizeSet ENDP




HexDword   PROC NEAR PASCAL USES EDX ECX, value:DWORD		; prints EAX
	mov dh,8
        mov ecx,DWORD PTR [value]
	INVOKE  HexSizeSet, 07
        RET
HexDword        ENDP


HexWord	      PROC NEAR PASCAL USES  EDX ECX,  value :DWORD        ; prints AX
	mov dh,4
        mov ecx,DWORD PTR [value]
	rol ecx,16
	INVOKE  HexSizeSet,07
        RET
HexWord        ENDP


HexByte	      PROC NEAR PASCAL USES  EDX ECX ,  value:DWORD          ; prints AL
	mov dh,2
        mov ecx,DWORD PTR [value]
	rol ecx,24
	INVOKE  HexSizeSet, 07
        RET
HexByte        ENDP



Hex_Dword   PROC NEAR PASCAL USES EDX ECX, value,Color:DWORD		; prints EAX
	mov dh,8
        mov ecx,DWORD PTR [value]
	INVOKE  HexSizeSet, color
        RET
Hex_Dword        ENDP


Hex_Word	      PROC NEAR PASCAL USES  EDX ECX,  value,Color:DWORD         ; prints AX
	mov dh,4
        mov ecx,DWORD PTR [value]
	rol ecx,16
	INVOKE  HexSizeSet, color
        RET
Hex_Word        ENDP


Hex_Byte	      PROC NEAR PASCAL USES  EDX ECX ,  value,Color:DWORD          ; prints AL
	mov dh,2
        mov ecx,DWORD PTR [value]
	rol ecx,24
	INVOKE  HexSizeSet, color
        RET
Hex_Byte        ENDP

;-------------------------------------------------------




; PRINT A CHARACTER 
; EXPECTS:
; al     character to print
; ah 	 attribute byte
; Cursor_X,Cursor_Y   position (X,Y) on the screen
PRINT_CHAR	proc near USES EAX EDX 
                ;-- line feed ----------------------------------
                cmp al,0Ah
                jnz no_feed
        	 	 inc Cursor_Y       ; move curser down a line
			jmp char_printed
no_feed:	;-- carage return ------------------------------------
                cmp al,0Dh
                jnz no_carg
        	 	 mov Cursor_X,0		; return curser to start
			jmp char_printed
   no_carg:	;-- print the character on the screen -----------------
                push	ax
                movzx	eax, Cursor_Y
		mov	edx,eax
		shl	eax,6
		shl	edx,4
		add	eax,edx
                movzx   edx,Cursor_X
                add     eax,edx
                shl     eax,1
                add     eax,_0b8000h
                pop     word ptr [eax]
                inc Cursor_X

		; ----- don't let the curser go off the screen -----------
char_printed:	  cmp Cursor_X,80
	         jb k23
        	  mov Cursor_X,0
                  inc Cursor_Y
	k23:      cmp Cursor_Y,25
	         jb k24
                  call Scroll_Screen
        	  mov Cursor_Y,24
	k24:      ret
PRINT_CHAR      endp





CODE32 ENDS
END
